<?php
error_reporting(E_ALL ^ E_DEPRECATED);
require_once($_SERVER['DOCUMENT_ROOT']."/api/REST.api.php");

include __DIR__.'/bin/load.php';


class API extends REST
{
    public $data = "";
    public $current_call;
    private $auth = null;

    public function __construct()
    {
        parent::__construct(); // Init parent contructor
    }

    /*
     * Public method for access api.
     * This method dynmically call the method based on the query string
     *
     */

    public function processApi(){
        $func = strtolower(trim(str_replace("/", "", $_REQUEST['rquest'])));
        
        if (method_exists($this, $func)) {
            $this->$func();
        } else {
            if (isset($_GET['namespace'])) {
                $dir = $_SERVER['DOCUMENT_ROOT'] . '/api/apis/' . $_GET['namespace'];
                $file = $dir . '/' . $func . '.php';
                
                if (file_exists($file)) {
                    include $file;
                    $this->current_call = Closure::bind(${$func}, $this, get_class());
                    $this->$func();
                    // $boundFunc = $this->current_call;
                    // $boundFunc();     // you can also do this with call
                } else {
                    $this->response($this->json(['error' => 'method_not_found']), 404);
                }
            } else {
                // We can even process functions without namespace here.
                $this->response($this->json(['error' => 'method_not_found']), 404);
            }
        }
    }
    

    public function auth(){
        $headers = getallheaders();
        if(isset($headers['Authorization'])){
            $token = explode(' ', $headers['Authorization']);
            $this->auth = new Auth($token[1]);
        }
    }

    public function isAuthenticated(){
        if($this->auth == null){
            return false;
        }
        if($this->auth->getOAuth()->authenticate() and isset($_SESSION['username'])){
            return true;
        } else {
            return false;
        }
    }

    public function getUsername(){
        return $_SESSION['username'];
    }

    public function die($e){
        $data = [
            "error" => $e->getMessage()
        ];
        $data = $this->json($data);
        $this->response($data,400);
    }


    public function __call($method, $args){
        if(is_callable($this->current_call)){
            return call_user_func_array($this->current_call, $args);
        } else {
            $this->response($this->json(['error'=>'method_not_callable']),404);
        }
    }


    /*************API SPACE START*******************/




    private function test()                     // This is for testing purpose
    {
        $data = $this->json(getallheaders());
        $this->response($data, 200);
    }

    private function request_info()
    {
        $data = $this->json($_SERVER);
        $this->response($data, 200);
    }


    /*************API SPACE END*********************/

    /*
    Encode array into JSON
    */
    private function json($data)
    {
        if (is_array($data)) {
            return json_encode($data, JSON_PRETTY_PRINT);
        } else {
            return "{FORMAT IS WRONG}";
        }
    }
}

// Initiiate Library

$api = new API;
try {
    $api->auth();
    $api->processApi();
} catch (Exception $e){
    $api->die($e);
}
