<?php
class Account
{
    public $id;
    private $db;
    private $data;
    private $authdata;

    public function __construct($id=null)
    {
        $this->db = database::getconnection();
        $this->getAuthinfo();
        if ($id != null) {
            $this->refresh($id);
        }
    }

    public function __call($name, $arguments)
    {
        $property = preg_replace("/[^0-9a-zA-Z]/", "", substr($name, 3));
        $property = strtolower(preg_replace('/\B([A-Z])/', '_$1', $property));

        if (substr($name, 0, 3) == "get") {
            return $this->_get_data($property);
        } elseif (substr($name, 0, 3) == "set") {
            return $this->_set_data($property, $arguments[0]);
        }
    }

    public function refresh($id)
    {
        $query = "SELECT * FROM `auth` WHERE `id` = '$id';";
        $result = $this->db->query($query);
        if ($result->num_rows == 1) {
            $this->data = $result->fetch_assoc();
            if ((($this->getOwner($this->data['id']) == $_SESSION['username'])) or $this->checkPermission()) {
                $this->id = $this->data["id"];
            }
            else
            {
                throw new Exception("Unauthorized");
            }
            
        } else {
            throw new Exception("account not found");
        }
    }

    public function getOwner($id)
    {
        $query = "SELECT username FROM auth WHERE `id` = '$id';";
        $result = $this->db->query($query);
        if ($result->num_rows == 1) {
            $data = $result->fetch_assoc();
            return $data["username"];
        }
    }

    private function _set_data($column, $value)
    {
        try {
            if ($this->id == null) {
                throw new Exception('User ID not available.');
            }
            $updateSql = "UPDATE `auth` SET `$column` = '$value' WHERE `id` = '$this->id'";
            if ($this->db->query($updateSql) === FALSE) {
                throw new Exception("Connection failed: " . $this->db->connect_error);
            }
        } catch (Exception $e) {
            echo "Exception caught: " . $e->getMessage();
        }
    }

    private function _get_data($column)
    {
        try {
            if ($this->id == null) {
                throw new Exception('User ID not available.');
            }
            $getSql = "SELECT $column FROM `auth` WHERE `id` = '$this->id'";
            $result = $this->db->query($getSql);

            if ($result === FALSE) {
                throw new Exception("Failed: " . $this->db->connect_error);
            }

            if ($result->num_rows == 1) {
                $row = $result->fetch_assoc();
                return $row[$column];
            }
        } catch (Exception $e) {
            echo "Exception caught: " . $e->getMessage();
        }
    }
    
    public function getAuthinfo()
    {
        $name = $_SESSION['username'];
        $this->authdata = new user($name);
        $this->id = $this->authdata->getId();
    }
    

    public function countusers()
    {
        $query = "SELECT COUNT(*) FROM `auth`;";
        $result = $this->db->query($query);
        if($result->num_rows>0){
            $data = $result->fetch_assoc();
            return $data['COUNT(*)'];
        }
        else{
            throw new Exception('something wrong');
        }
    }

    private function checkPermission() {
        if (!isset($_SESSION['username'])) {
            throw new Exception("User not authenticated");
        }

        $username = $_SESSION['username'];
        $query = "SELECT * FROM `auth` WHERE `username` = '$username'";
        $result = $this->db->query($query);

        if ($result->num_rows == 1) {
            $data = $result->fetch_assoc();
            if ($data["role"] == "admin") {
                return true;
            }
            else
            {
                throw new Exception("unauthorized");
            }
        } else {
            throw new Exception("User not found" .$username);
        }
    }

    public function getallacc($page, $limit=10)
     {
        if($this->checkPermission())
        {
        $offset = ($page - 1) * $limit;
        $query = "SELECT id , username , email , createdat, active , role FROM `auth` LIMIT $offset, $limit";
        $result = $this->db->query($query);

        $users = [];
        while ($row = $result->fetch_assoc())
        {
            $users[] = $row;
        }
            return $users;
        }
        else
        {
           throw new Exception("unauthorized");
        }
    }

    public function logout()
    {
        $query = "DELETE FROM `session` WHERE `access_token` = '$_SESSION[token]';";
        $result = $this->db->query($query);
        if($result)
        {   
            session_unset();
            session_destroy();
            return "logout successful";
        }
        else
        {
            throw new Exception("something went wrong");
        }
    }
    
   

    public function deleteAccount()
    {   
        $profile = new Userprofile();
        $profile->deleteprofile($this->id);
        $query = "DELETE FROM `auth` WHERE `id` = $this->id";
        $result = $this->db->query($query);
        if($result)
        {
            return "Account deleted";
        }
        else
        {
            throw new Exception("something went wrong");
        }
        
    }
}
