<?php

/**
 * this auth class going to handle the  auth login and token login
 */
class auth 
{
 private $token;
 public $username;
 public $password;
 public $isTokenAuth = false;
 private $loginTokens = null;
 private $oauth;

    public function __construct($username,$password = null)
    {
        if($password == null)
        {
            // token based authentication
            $this->isTokenAuth=true;
            $this->token = $username;
        }
        else
        {
            $this->username = $username;
            $this->password = $password;
        }
        if($this->isTokenAuth)
        {
            $this->oauth = new OAuth($this->token);
            $this->oauth->authenticate();
        }
        else
        {
            $user = new user($this->username);
            $hash = $user->gethassedpassword();
            if(password_verify($this->password,$hash))
            {
                if(!$user->isActive())
                {
                    throw new exception("Plz verify your email by checking your inbox to verify it..");
                }
                $this->loginTokens = $this->addSession();
            }
            else
            {
                throw new exception("password mismatch");
            }

        }
    }

    /**
     * Returns the username of authenticated user
     */
    public function getUsername(){
        if($this->oauth->authenticate()){
            return $this->oauth->getUsername();
        } else {
            return "a";
        }
    }

    public function getOAuth(){
        return $this->oauth;
    }


    public function getAuthTokens(){
        return $this->loginTokens;
    }


    private function addSession(){
        $oauth = new OAuth();
        $oauth->SetUsername($this->username);
        $session = $oauth->newSession();
        return $session;
    }



    public static function generateRandomHash($len)
    {
        $bytes = random_bytes($len);
        return bin2hex($bytes);
    }
}