<?php

/**
 * this oauth class generate the tokens for the login user
 * and if the access token is invalid we can renewal the access token by refresh token
 */
class OAuth {
    private $db;
    private $refresh_token = null;
    private $access_token = null;
    private $valid_for = 7200;
    private $username;


    public function __construct($token = NULL){
        $this->db = database::getconnection();
        if($token != NULL){
            if($this->startsWith($token, 'a.')){
                $this->access_token = $token;
            } else if($this->startsWith($token, 'r.')){
                $this->refresh_token = $token;
            } else {
                $this->setUsername($token);
            }
        }
    }


    public function SetUsername($username)
    {
        $u = new User($username);
        $this->username = $username;
    }

    public function getUsername()
    {
        return $this->username;
    }
    // this function is used to add the session
    public function newSession($valid_for = 7200,$reference_token ='auth_grant'){
        if($this->username == NULL){
            throw new Exception("Username not set for OAuth");
        }
        $this->valid_for = $valid_for;
        $this->access_token = 'a.'.auth::generateRandomHash(32);
        if($reference_token == 'auth_grant')
        {
        $this->refresh_token = 'r.'.auth::generateRandomHash(32);
        }else{
        $this->refresh_token = 'd.'.auth::generateRandomHash(16);
        }
        $query = "INSERT INTO `session` (`username`, `access_token`, `created_at`, `active`, `refresh_token`, `valid_for`, `reference_token`)
        VALUES ('$this->username', '$this->access_token', now(), '1', '$this->refresh_token', '$valid_for', '$reference_token');";
        if($this->db->query($query)){
            return array(
                "access_token" => $this->access_token,
                "valid_for" => $this->valid_for,
                "refresh_token" => $this->refresh_token,
                "reference_token" => $reference_token,
                "type" => 'api'
            );
        } else {
            throw new Exception($this->db->error);
        }
    }
  // this is function is used to verify the token                                                   
    public function authenticate(){
        if($this->access_token != null){
            $query = "SELECT * FROM `session` WHERE `access_token` = '$this->access_token'";
            $result = $this->db->query($query);
            if($result){
                $data = $result->fetch_assoc();
                $created_at = strtotime($data['created_at']);
                $expires_at = $created_at + $data['valid_for'];

                if(time() <= $expires_at){
                    if (session_status() === PHP_SESSION_NONE) {
                        session_start();
                    }
                    $this->username = $_SESSION['username'] = $data['username'];
                    $_SESSION['token'] = $this->access_token;
                    return true;
                } else {
                   throw new Exception("Expired token");
                }
            } else {
                throw new Exception($this->db->error);
            }
        }
    }

// this function is used to refresh the access token
    public function refreshAccess(){
        if($this->refresh_token and !($this->startsWith($this->refresh_token,'d.'))){
            $query = "SELECT * FROM `session` WHERE `refresh_token` = '$this->refresh_token'";
            $result = $this->db->query($query);
            if($result){
                $data = $result->fetch_assoc();
                $this->username = $data['username'];
                if($data['active'] == 1)
                {
                    return $this->newSession(7200,$this->refresh_token);
                }
                    else{
                        throw new Exception("Expired token");
                    }
            } else {
                throw new Exception($this->db->error);
            }
        }
        else{
            throw new Exception("Invalid request");
        }
    }

    private function startsWith ($string, $startString){
        $len = strlen($startString);
        return (substr($string, 0, $len) === $startString);
    }

}