<?php
/**
 * this userprofile class is used to create , update , read , delete the userprofile
 */
class Userprofile
{
    public $id;
    public $profileid;
    private $db;
    private $data;
    private $authdata;

    public function __construct()
    {
        $this->db = database::getconnection();
        $this->getAuthinfo();                // using the function we take name from session and construct the user class
        
    }



    public function getOwner($id)
    {
        $query = "SELECT username FROM auth WHERE `id` = '$id';";
        $result = $this->db->query($query);
        if ($result->num_rows == 1) {
            $data = $result->fetch_assoc();
            return $data["username"];
        }
    }

    public function __call($name, $arguments)
    {
        $property = preg_replace("/[^0-9a-zA-Z]/", "", substr($name, 3));
        $property = strtolower(preg_replace('/\B([A-Z])/', '_$1', $property));

        if (substr($name, 0, 3) == "get") {
            return $this->_get_data($property);
        } elseif (substr($name, 0, 3) == "set") {
            return $this->_set_data($property, $arguments[0]);
        }
    }


    public function getAuthinfo()
    {
        $name = $_SESSION['username'];
        $this->authdata = new user($name);
        $this->id = $this->authdata->getId();
    }

    public function new($firstname, $lastname, $phoneno, $gender, $bio, $profile, $dob)
    {
        if (isset($_SESSION["username"]) and $this->authdata->getUsername() == $_SESSION["username"]) {
            $query = "INSERT INTO `userprofile` (`id`, `firstname`, `lastname`, `mobileno`, `gender`, `bio`, `profile`, `dob`)
            VALUES ('$this->id', '$firstname', '$lastname', '$phoneno', '$gender', '$bio', '$profile', '$dob');";

            $result = $this->db->query($query);
            if (!$result) {
                throw new Exception("Something went wrong");
            }
        } else {
            throw new Exception("unauthorized");
        }
    }

    private function _set_data($column, $value)
    {
        try {
            if ($this->id == null) {
                throw new Exception('User ID not available.');
            }
            $updateSql = "UPDATE `userprofile` SET `$column` = '$value' WHERE `id` = '$this->id'";
            if ($this->db->query($updateSql) === FALSE) {
                throw new Exception("Connection failed: " . $this->db->connect_error);
            }
        } catch (Exception $e) {
            echo "Exception caught: " . $e->getMessage();
        }
    }

    private function _get_data($column)
    {
        try {
            if ($this->id == null) {
                throw new Exception('User ID not available.');
            }
            $getSql = "SELECT $column FROM `userprofile` WHERE `id` = '$this->id'";
            $result = $this->db->query($getSql);

            if ($result === FALSE) {
                throw new Exception("Failed: " . $this->db->connect_error);
            }

            if ($result->num_rows == 1) {
                $row = $result->fetch_assoc();
                return $row[$column];
            }
        } catch (Exception $e) {
            echo "Exception caught: " . $e->getMessage();
        }
    }

    private function checkPermission()
    {
        if (!isset($_SESSION['username'])) {
            throw new Exception("User not authenticated");
        }

        $username = $_SESSION['username'];
        $query = "SELECT * FROM `auth` WHERE `username` = '$username'";
        $result = $this->db->query($query);

        if ($result->num_rows == 1) {
            $data = $result->fetch_assoc();
            if ($data["role"] == "admin") {
                return true;
            } else {
                return false;
            }
        } else {
            throw new Exception("User not found" . $username);
        }
    }

    public function deleteprofile($id)
    {
        $name = $this->authdata->getUsername();
        if($this->checkPermission() or $name == $_SESSION['username'])
        {
            $query = "DELETE FROM `userprofile` WHERE `id` = $id";
            $result = $this->db->query($query);
            if($result)
            {
            return "profile deleted";
            }
            else
            {
                throw new Exception("something went wrong");
            }
        }
        else
        {
            throw new Exception("unauthorized");
        }
        
    }

    public function countusers()
    {
        $query = "SELECT COUNT(*) FROM `userprofile`;";
        $result = $this->db->query($query);
        if($result->num_rows>0){
            $data = $result->fetch_assoc();
            return $data['COUNT(*)'];
        }
        else{
            throw new Exception('something wrong');
        }
    }

    public function getallUsers($page, $limit=10)
     {
        if($this->checkPermission())
        {
        $offset = ($page - 1) * $limit;
        $query = "SELECT * FROM `userprofile` LIMIT $offset, $limit";
        $result = $this->db->query($query);

        $users = [];
        while ($row = $result->fetch_assoc())
        {
            $users[] = $row;
        }
            return $users;
        }
        else
        {
           throw new Exception("unauthorized");
        }
    }

}
